/*
 * Crystal2D_Canvas Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;

   public class Crystal2D_Canvas extends Canvas implements MouseListener, MouseMotionListener {
      static Image offScrImage;
      static Graphics image_handle;
   
      static Crystal2D parent;
   
      static int xoff = 4;
      static int yoff = 4;
   
      static int img_x;
      static int img_y;
   
      Dimension dim;
   
      static int x_pixels;
      static int y_pixels;
   
      static int gsx;
      static int gsy;
   
      static int old_gridsize = -99; 
      static int new_gridsize;
   
   
      // constructor
      Crystal2D_Canvas(Crystal2D mother) {
         parent = mother;
      
         addMouseMotionListener(this);
         addMouseListener(this);
      }
   
      // methods
      final public void start_up() {
         img_x = (Crystal2D_Grid.hside) * (Crystal2D_Grid.gridsize);
         img_y = (Crystal2D_Grid.vside) * (Crystal2D_Grid.gridsize);
      
         // System.out.println("hudfiehui : " + Crystal2D_Grid.gridsize);
      
         if (Crystal2D_Grid.isHexagonal() != 0) {
            img_y = img_y - (img_y >>> 2) + (Crystal2D_Grid.gridsize >>> 2);
            img_x = img_x + (Crystal2D_Grid.gridsize >>> 1);
         }
      
         offScrImage = createImage(img_x, img_y); 
      
         image_handle = offScrImage.getGraphics();
      
         Crystal2D_Grid.RepaintAll = true;
      }
   
   
      final public static void forceResize() {
         old_gridsize = -1;
      
         // Crystal2D_Grid.RepaintAll = true;
      }
   
   // draw
      final public void update(Graphics g) {
         dim = getSize();
         x_pixels = dim.width;
         y_pixels = dim.height;
      
         gsx = ((x_pixels / Crystal2D_Grid.hside) >>> 1) << 1;
         gsy = ((y_pixels / Crystal2D_Grid.vside) >>> 1) << 1;
      
         if (Crystal2D_Grid.isHexagonal() != 0) {
            //if (Crystal2D_Grid.geometry == Crystal2D_Grid.TRIUMPHANT) {
               //gsx = ((x_pixels / (Crystal2D_Grid.hside)) >>> 3) << 3;
               //gsy = ((y_pixels) / 6 / Crystal2D_Grid.vside) << 3;
            //}
            //else
            //{
            gsx = ((x_pixels / (Crystal2D_Grid.hside)) >>> 2) << 2;
            gsy = ((y_pixels) / 3 / Crystal2D_Grid.vside) << 2;
            //}
         }
      
         new_gridsize = (gsx > gsy) ? gsy : gsx;
         if (new_gridsize != old_gridsize) {
            // if (Crystal2D.busy == 0) {
            g.setColor(Color.black);
            g.fillRect(0,0,9999,9999);
             // }
         
            old_gridsize = new_gridsize;
            Crystal2D_Grid.setGridSize(new_gridsize);
            start_up();
         
            Crystal2D_Grid.RepaintAll = true;
         }
      
         // Crystal2D_Grid.gridsize = (gsx > gsy) ? gsy : gsx;
      
         xoff = (x_pixels >> 1) - ((Crystal2D_Grid.gridsize * Crystal2D_Grid.hside + (Crystal2D_Grid.gridsize >>> 1)) >>> 1);
         yoff = (y_pixels >> 1) - ((Crystal2D_Grid.gridsize * Crystal2D_Grid.vside + (Crystal2D_Grid.gridsize >>> 2)) >>> 1);
      
         if (Crystal2D_Grid.isHexagonal() != 0) {
            yoff += (Crystal2D_Grid.gridsize * Crystal2D_Grid.vside) >>> 3;
         }
      
         if ((((Crystal2D_Grid.generation) & parent.frame_frequency) == 0) || (parent.paused != 0)) {
            // if (offScrImage != null) // needed due to some sort of bug (at Sun's end?)
            g.drawImage(offScrImage,xoff,yoff,this);
         }
      }
   
   
      final public void paint(Graphics g) {
         update(g);
         //if (((Crystal2D_Grid.generation) & frame_frequency) == 0)
            //if (offScrImage != null) // needed due to some sort of bug (at Sun's end?)
               //g.drawImage(offScrImage,xoff,yoff,this);
      }
   
      final public int adjustHexY(int temp_y) {
         if (Crystal2D_Grid.isHexagonal() != 0) {
            return (((temp_y - yoff) * 4) / 3) / Crystal2D_Grid.halfgridsize;
         }
         else
         {
            return (temp_y - yoff) / Crystal2D_Grid.halfgridsize;
         }
      }
   
   
   // mouse motion...
      public void mouseReleased(MouseEvent e) {
         parent.mouse_pressed = 0;
         parent.newmessage(parent.MOUSE_CLICK,(e.getX() - xoff) / (Crystal2D_Grid.halfgridsize),adjustHexY(e.getY()));
      }
   
   
      public void mousePressed(MouseEvent e) {
         parent.mouse_pressed = 1;
         parent.newmessage(parent.MOUSE_CLICK,(e.getX() - xoff) / (Crystal2D_Grid.halfgridsize),adjustHexY(e.getY()));
      }
   
   
      public void mouseDragged(MouseEvent e) {
         parent.newmessage(parent.MOUSE_DRAG,(e.getX() - xoff) / (Crystal2D_Grid.halfgridsize),adjustHexY(e.getY()));
      }
   
   
      public void mouseClicked(MouseEvent e) {
      }
   
   
      public void mouseEntered(MouseEvent e) {
         parent.newmessage(parent.MOUSE_ENTRY,(e.getX() - xoff) / (Crystal2D_Grid.halfgridsize),adjustHexY(e.getY()));
      }
   
   
   
      public void mouseExited(MouseEvent e) {
      }
   
   
      public void mouseMoved(MouseEvent e) {
      }
   
   }
